//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
#include "fstream.h"
#include "frmsched.h"
#include "config.h"

//---------------------------------------------------------------------------
#pragma link "Grids"
#pragma resource "*.dfm"

TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::TimerTimer(TObject *Sender)
{
  gettime(&TheTime);
  sprintf(strTheTime, "%02d:%02d:%02d", TheTime.ti_hour, TheTime.ti_min, TheTime.ti_sec);
  ExcecuteAnyPresentlyScheduledPrograms(strTheTime);
}
//---------------------------------------------------------------------------
void TMainForm::ExcecuteAnyPresentlyScheduledPrograms(const char* strTheTime)
{

  for (int i = lstboxTime->Items->Count; i > 0; i--) {
     String TempString = lstboxProgramPath->Items->Strings[i-1];
     char* NullString = &TempString[1] + NULL; 
     if ((lstboxTime->Items->Strings[i-1]+":00") == strTheTime) WinExec(NullString, 1);
  }
}
void __fastcall TMainForm::InitializeSchedule()
{
  //  FileStream
  String IniLineString, newIniLineString;
  ifstream fin(IniFileName.c_str());		// declare input file
  if (!fin)
    MessageBox(0, "File I/O Error", "No INI File", MB_ICONASTERISK);
  else
  {
    char tempstr[256];
    while (!fin.eof())
    {
  	   fin.getline(tempstr, 255);
       IniLineString = String(tempstr, 255);
       newIniLineString = IniLineString.Trim();
       ParseFileInput(newIniLineString.c_str());
    }
    fin.close();
  }
}

char* __fastcall TMainForm::ParseFileInput(char* FileInput)
{
   int ParseCount = 0;
   char *ParsedString = strtok(FileInput, ";");  // parse strings components, the
   							                     // individual components separated
                              					 // by the a semi-colon ";"
   while (ParsedString) {
     AddParsedStringToList(ParsedString, ++ParseCount);
     ParsedString = strtok(NULL, ";");
   }

   return NULL;
}
void __fastcall TMainForm::AddParsedStringToList(const char* ParsedString, int ParseCount)
{
    switch (ParseCount) {
      case 1:
        {
          //Add To Description List
          lstboxDescription->Items->Add(ParsedString);
		}
        break;
      case 2:
        {
          //Add To Time List
          lstboxTime->Items->Add(ParsedString);
        }
        break;
      case 3:
        {
          //add To Path List
          lstboxProgramPath->Items->Add(ParsedString);
        }
        break;
     default:
        {
          MessageBox(0, "Error Occurred While Parseng Your INI File", "Sched.INI Error", MB_ICONASTERISK);
        } //end default case
     }
}

void __fastcall TMainForm::FormCreate(TObject *Sender)
{
  IniFileName = "sched.ini";
  InitializeSchedule();
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::AddEvent1Click(TObject *Sender)
{
     frmConfig->InEditConfigMode = false;
     frmConfig->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::lstboxDescriptionClick(TObject *Sender)
{
 lstboxTime->ItemIndex = lstboxDescription->ItemIndex;
 lstboxProgramPath->ItemIndex = lstboxDescription->ItemIndex;

}
//---------------------------------------------------------------------------
void __fastcall TMainForm::lstboxTimeClick(TObject *Sender)
{
 lstboxProgramPath->ItemIndex = lstboxTime->ItemIndex;
 lstboxDescription->ItemIndex = lstboxTime->ItemIndex;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::lstboxProgramPathClick(TObject *Sender)
{
 lstboxTime->ItemIndex = lstboxProgramPath->ItemIndex;
 lstboxDescription->ItemIndex = lstboxProgramPath->ItemIndex;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::RemoveEvent1Click(TObject *Sender)
{

 if (lstboxTime->ItemIndex > -1)
    lstboxTime->Items->Delete(lstboxTime->ItemIndex);
 if (lstboxDescription->ItemIndex > -1)
    lstboxDescription->Items->Delete(lstboxDescription->ItemIndex);
 if (lstboxProgramPath->ItemIndex > -1)
    lstboxProgramPath->Items->Delete(lstboxProgramPath->ItemIndex);
 frmConfig->InEditConfigMode = false;
 frmConfig->SaveConfigToFile();
 }
//---------------------------------------------------------------------------

void __fastcall TMainForm::lstboxDescriptionDblClick(TObject *Sender)
{
     frmConfig->EditDesc->Text        = lstboxDescription->Items->Strings[lstboxDescription->ItemIndex];
     frmConfig->EditTime->Text        = lstboxTime->Items->Strings[lstboxTime->ItemIndex];
     frmConfig->EditProgramPath->Text = lstboxProgramPath->Items->Strings[lstboxProgramPath->ItemIndex];
     frmConfig->InEditConfigMode = true;
     frmConfig->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Exit1Click(TObject *Sender)
{
	Close();	
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::btnExitClick(TObject *Sender)
{
	Close();	
}
//---------------------------------------------------------------------------
